Loading...
Searching...
No Matches
GxService Class Reference

`#include <jsonrpc.h>`

Inheritance diagram for GxService:

## Classes

struct | ChangedPlugin

## Public Member Functions

| GxService (gx_preset::GxSettings &settings_, gx_jack::GxJack &jack_, TunerSwitcher &tunerswitcher, sigc::slot< void > quit_mainloop_, const Glib::ustring &host, int *port)
| ~GxService ()
void | send_rack_changed (bool stereo, CmdConnection *cmd)
void | ladspaloader_update_plugins (gx_system::JsonWriter *jw, CmdConnection *cmd)
float | update_maxlevel (const std::string &id, bool reset=false)

## Private Member Functions

virtual bool | on_incoming (const Glib::RefPtr< Gio::SocketConnection > &connection, const Glib::RefPtr< Glib::Object > &source_object)
void | save_state ()
void | remove_connection (CmdConnection *p)
bool | broadcast_listeners (CmdConnection::msg_type n, CmdConnection *sender=0)
void | broadcast (gx_system::JsonStringWriter &jw, CmdConnection::msg_type n, CmdConnection *sender=0)
bool | idle_broadcast_handler ()
void | connect_value_changed_signal (gx_engine::Parameter *p)
void | serialize_parameter_change (gx_system::JsonWriter &jw)
void | ladspaloader_write_changes (gx_system::JsonWriter &jw, std::vector< ChangedPlugin > &changed_plugins)
void | on_param_insert_remove (gx_engine::Parameter *p, bool insert)
void | on_param_value_changed (gx_engine::Parameter *p)
void | preset_changed ()
void | on_engine_state_change (gx_engine::GxEngineState state)
void | on_tuner_freq_changed ()
void | display (const Glib::ustring &bank, const Glib::ustring &preset)
void | set_display_state (TunerSwitcher::SwitcherState newstate)
void | on_selection_done (bool v)
void | on_presetlist_changed ()
void | on_log_message (const string &msg, GxLogger::MsgType tp, bool plugged)
void | on_midi_changed ()
void | on_midi_value_changed (int ctl, int value)
void | on_rack_unit_changed (bool stereo)
void | create_bluetooth_sockets (const Glib::ustring &host)

## Static Private Member Functions

static void | add_changed_plugin (gx_engine::Plugin *pl, gx_engine::PluginChange::pc v, std::vector< ChangedPlugin > &vec)

## Private Attributes

gx_preset::GxSettings & | settings
gx_jack::GxJack & | jack
TunerSwitcher & | tuner_switcher
sigc::slot< void > | quit_mainloop
time_t | oldest_unsaved
time_t | last_change
sigc::connection | save_conn
std::list< CmdConnection * > | connection_list
std::queue< broadcast_data > | broadcast_list
gx_system::JsonStringWriter * | jwc
std::map< std::string, bool > * | preg_map
std::map< std::string, float > | maxlevel

## Friends

class | CmdConnection

## Detailed Description

Definition at line 124 of file jsonrpc.h.

## Constructor & Destructor Documentation

## GxService()

GxService::GxService | ( | gx_preset::GxSettings & | settings_,
|  | gx_jack::GxJack & | jack_,
|  | TunerSwitcher & | tunerswitcher,
|  | sigc::slot< void > | quit_mainloop_,
|  | const Glib::ustring & | host,
|  | int * | port )

## ~GxService()

GxService::~GxService | ( |  | ) |

## Member Function Documentation

## add_changed_plugin()

void GxService::add_changed_plugin | ( | gx_engine::Plugin * | pl,
|  | gx_engine::PluginChange::pc | v,
|  | std::vector< ChangedPlugin > & | vec )

static private

## broadcast()

void GxService::broadcast | ( | gx_system::JsonStringWriter & | jw,
|  | CmdConnection::msg_type | n,
|  | CmdConnection * | sender = 0 )

private

## broadcast_listeners()

bool GxService::broadcast_listeners | ( | CmdConnection::msg_type | n,
|  | CmdConnection * | sender = 0 )

private

## connect_value_changed_signal()

void GxService::connect_value_changed_signal | ( | gx_engine::Parameter * | p | ) |

private

## create_bluetooth_sockets()

void GxService::create_bluetooth_sockets | ( | const Glib::ustring & | host | ) |

private

## display()

void GxService::display | ( | const Glib::ustring & | bank,
|  | const Glib::ustring & | preset )

private

## idle_broadcast_handler()

bool GxService::idle_broadcast_handler | ( |  | ) |

private

## ladspaloader_update_plugins()

void GxService::ladspaloader_update_plugins | ( | gx_system::JsonWriter * | jw,
|  | CmdConnection * | cmd )

## ladspaloader_write_changes()

void GxService::ladspaloader_write_changes | ( | gx_system::JsonWriter & | jw,
|  | std::vector< ChangedPlugin > & | changed_plugins )

private

## on_engine_state_change()

void GxService::on_engine_state_change | ( | gx_engine::GxEngineState | state | ) |

private

## on_incoming()

virtual bool GxService::on_incoming | ( | const Glib::RefPtr< Gio::SocketConnection > & | connection,
|  | const Glib::RefPtr< Glib::Object > & | source_object )

private virtual

## on_log_message()

void GxService::on_log_message | ( | const string & | msg,
|  | GxLogger::MsgType | tp,
|  | bool | plugged )

private

## on_midi_changed()

void GxService::on_midi_changed | ( |  | ) |

private

## on_midi_value_changed()

void GxService::on_midi_value_changed | ( | int | ctl,
|  | int | value )

private

## on_param_insert_remove()

void GxService::on_param_insert_remove | ( | gx_engine::Parameter * | p,
|  | bool | insert )

private

## on_param_value_changed()

void GxService::on_param_value_changed | ( | gx_engine::Parameter * | p | ) |

private

## on_presetlist_changed()

void GxService::on_presetlist_changed | ( |  | ) |

private

## on_rack_unit_changed()

void GxService::on_rack_unit_changed | ( | bool | stereo | ) |

private

## on_selection_done()

void GxService::on_selection_done | ( | bool | v | ) |

private

## on_tuner_freq_changed()

void GxService::on_tuner_freq_changed | ( |  | ) |

private

## preset_changed()

void GxService::preset_changed | ( |  | ) |

private

## remove_connection()

void GxService::remove_connection | ( | CmdConnection * | p | ) |

private

## save_state()

void GxService::save_state | ( |  | ) |

private

## send_rack_changed()

void GxService::send_rack_changed | ( | bool | stereo,
|  | CmdConnection * | cmd )

## serialize_parameter_change()

void GxService::serialize_parameter_change | ( | gx_system::JsonWriter & | jw | ) |

private

## set_display_state()

void GxService::set_display_state | ( | TunerSwitcher::SwitcherState | newstate | ) |

private

## update_maxlevel()

float GxService::update_maxlevel | ( | const std::string & | id,
|  | bool | reset = false )

## Friends And Related Symbol Documentation

## CmdConnection

friend class CmdConnection

friend

Definition at line 176 of file jsonrpc.h.

Referenced by broadcast(), broadcast_listeners(), CmdConnection, ladspaloader_update_plugins(), remove_connection(), and send_rack_changed().

## Member Data Documentation

## broadcast_list

std::queue<broadcast_data> GxService::broadcast_list

private

Definition at line 140 of file jsonrpc.h.

## connection_list

std::list<CmdConnection*> GxService::connection_list

private

Definition at line 139 of file jsonrpc.h.

## jack

gx_jack::GxJack& GxService::jack

private

Definition at line 133 of file jsonrpc.h.

## jwc

gx_system::JsonStringWriter* GxService::jwc

private

Definition at line 141 of file jsonrpc.h.

## last_change

time_t GxService::last_change

private

Definition at line 137 of file jsonrpc.h.

## maxlevel

std::map<std::string,float> GxService::maxlevel

private

Definition at line 143 of file jsonrpc.h.

## oldest_unsaved

time_t GxService::oldest_unsaved

private

Definition at line 136 of file jsonrpc.h.

## preg_map

std::map<std::string,bool>* GxService::preg_map

private

Definition at line 142 of file jsonrpc.h.

## quit_mainloop

sigc::slot<void> GxService::quit_mainloop

private

Definition at line 135 of file jsonrpc.h.

## save_conn

sigc::connection GxService::save_conn

private

Definition at line 138 of file jsonrpc.h.

## settings

gx_preset::GxSettings& GxService::settings

private

Definition at line 132 of file jsonrpc.h.

## tuner_switcher

TunerSwitcher& GxService::tuner_switcher

private

Definition at line 134 of file jsonrpc.h.

The documentation for this class was generated from the following file:

- src/headers/jsonrpc.h